/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ParamCanjePuntoDAO;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.ParamCanjePunto;
import com.rjconsultores.ventaboletos.service.ParamCanjePuntoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("paramCanjePuntoService")
public class ParamCanjePuntoServiceImpl implements ParamCanjePuntoService {

    @Autowired
    private ParamCanjePuntoDAO paramCanjePuntoDAO;

    public List<ParamCanjePunto> obtenerTodos() {
        return paramCanjePuntoDAO.obtenerTodos();
    }

    public ParamCanjePunto obtenerID(Integer id) {
        return paramCanjePuntoDAO.obtenerID(id);
    }

    @Transactional
    public ParamCanjePunto suscribir(ParamCanjePunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramCanjePuntoDAO.suscribir(entidad);
    }

    @Transactional
    public ParamCanjePunto actualizacion(ParamCanjePunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramCanjePuntoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ParamCanjePunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        paramCanjePuntoDAO.actualizacion(entidad);
    }

    public List<ParamCanjePunto> buscar(Parada origem, Parada destino, Date ini, Date fim) {
        return paramCanjePuntoDAO.buscar(origem, destino, ini, fim);
    }
}
